## ismrmrd 1.3.3

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)
foreach(p
    CMP0025 # CMake 3.0 Compiler id for Apple Clang is now ``AppleClang``.
    CMP0042 # CMake 3.0 ``MACOSX_RPATH`` is enabled by default.
    CMP0046 # CMake 3.0 Error on non-existent dependency in add_dependencies.
    CMP0054 # CMake 3.1 Only interpret ``if()`` arguments as variables or keywords when unquoted.
    CMP0056 # CMake 3.2 Honor link flags in ``try_compile()`` source-file signature.
    CMP0058 # CMake 3.3 Ninja requires custom command byproducts to be explicit.
    )
  if(POLICY ${p})
    cmake_policy(SET ${p} NEW)
  endif()
endforeach()
project(ISMRMRD)

# set project specific cmake module path
set (ISMRMRD_CMAKE_DIR ${PROJECT_SOURCE_DIR}/cmake CACHE PATH
  "Location of CMake scripts")

# command line options
option(USE_SYSTEM_PUGIXML "Use pugixml installed on the system" OFF)

# and include it to the search list
list(APPEND CMAKE_MODULE_PATH ${ISMRMRD_CMAKE_DIR})

# whether to install dependencies
if (WIN32)
    option(ISMRMRD_INSTALL_DEPENDENCIES "Install ismrmrd dependencies in windows" Off)
endif ()

# set the build type to Release if not specified
if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE Release CACHE STRING
      "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel."
      FORCE)
endif()

# compiler flags
if (WIN32)
    add_definitions(-DWIN32 -D_WIN32 -D_WINDOWS)
    add_definitions(-DUNICODE -D_UNICODE)
    add_definitions(-D_CRT_SECURE_NO_WARNINGS)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /EHsc")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /W3")
    set(CMAKE_EXE_LINKER_FLAGS_DEBUG "/debug /INCREMENTAL:NO")
    set(CMAKE_SHARED_LINKER_FLAGS_DEBUG "/debug /INCREMENTAL:NO")
    set(CMAKE_STATIC_LINKER_FLAGS_DEBUG "/debug /INCREMENTAL:NO")
    set(CMAKE_MODULE_LINKER_FLAGS_DEBUG "/debug /INCREMENTAL:NO")
    add_definitions(-D__func__=__FUNCTION__)
else ()
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=c99 -Wall")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall")
endif ()

#  ---   VERSIONING  (begin) ----
#The ISMRMRD convention is to use version numbers with the format:
#   XX.YY.ZZ (major, minor, patch)
#
#The major number increments when the binary compatibility of
#the fixed memory layout struts (e.g. AcquisitionHeader) is broken.
#The minor number changes when there are changes to the XML schema for
#the flexible header. The micro number changes when there are small changes
#in the utility libraries, that don't affect the data format itself.
# For more information see http://semver.org/
set(ISMRMRD_VERSION_MAJOR 1)
set(ISMRMRD_VERSION_MINOR 3)
set(ISMRMRD_VERSION_PATCH 3)
set(ISMRMRD_VERSION_STRING ${ISMRMRD_VERSION_MAJOR}.${ISMRMRD_VERSION_MINOR}.${ISMRMRD_VERSION_PATCH})
set(ISMRMRD_SOVERSION ${ISMRMRD_VERSION_MAJOR}.${ISMRMRD_VERSION_MINOR})

set(ISMRMRD_XML_SCHEMA_SHA1 "9b899c6ad806bc2388c70461d6e5affe5cc6d750")

#Remove line breaks and white space that does not change the meaning of the schema
file(STRINGS ${CMAKE_SOURCE_DIR}/schema/ismrmrd.xsd SCHEMA_STRINGS) #Read all strings from file
string(REPLACE ";" "" SCHEMA_NO_BREAKS  ${SCHEMA_STRINGS}) #Concatenate the list of strings
string(REGEX REPLACE ">[ \t]+<" "><" SCHEMA_NO_SPACE ${SCHEMA_NO_BREAKS}) #Remove spaces and tabs
string(STRIP ${SCHEMA_NO_SPACE} SCHEMA_NO_SPACE) #Strip any leading/trailing whitespace
set(ISMRMRD_SCHEMA_DIR ${CMAKE_CURRENT_BINARY_DIR})
file(WRITE ${ISMRMRD_SCHEMA_DIR}/ismrmrd_no_white_space.xsd ${SCHEMA_NO_SPACE}) #Write to file

#Now hash the cleaned up file
file(SHA1 ${CMAKE_CURRENT_BINARY_DIR}/ismrmrd_no_white_space.xsd ISMRMRD_CURRENT_XML_SCHEMA_SHA1)

#Compare to last known hash
if (NOT (${ISMRMRD_XML_SCHEMA_SHA1} STREQUAL ${ISMRMRD_CURRENT_XML_SCHEMA_SHA1}))
  message("")
  message("-----------------------------------------------")
  message("            !!VERSION ERROR!!                  ")
  message("                                               ")
  message(" Expected SHA1 hash:                           ")
  message("    ${ISMRMRD_XML_SCHEMA_SHA1}")
  message(" Actual SHA1 hash:                             ")
  message("    ${ISMRMRD_CURRENT_XML_SCHEMA_SHA1}")
  message("                                               ")
  message(" The XML Schema (ismrmrmd.xsd) has changed and ")
  message(" the MINOR version number should be increased  ")
  message(" and the SHA1 has should be updated in the     ")
  message(" CMakelists.txt file.                          ")
  message("                                               ")
  message(" If you don't know what this message means, you")
  message(" probably shouldn't be changing anything       ")
  message("-----------------------------------------------")
  message("")
  message(FATAL_ERROR "     FATAL XML VERSION ERROR")
endif()


# Find HDF5 for dataset support
find_package(HDF5 1.8 COMPONENTS C)

if (HDF5_FOUND)
    set (ISMRMRD_DATASET_SUPPORT true)
    set (ISMRMRD_DATASET_SOURCES libsrc/dataset.c libsrc/dataset.cpp)
    set (ISMRMRD_DATASET_INCLUDE_DIR ${HDF5_C_INCLUDE_DIR})
    set (ISMRMRD_DATASET_LIBRARIES ${HDF5_LIBRARIES})
else ()
    set (ISMRMRD_DATASET_SUPPORT false)
    message (WARNING "HDF5 not found. Dataset and file support unavailable!")
endif ()

# Generate the version.h header file
find_package(Git)
if (GIT_FOUND)
    execute_process(COMMAND ${GIT_EXECUTABLE} rev-parse HEAD WORKING_DIRECTORY
            ${CMAKE_SOURCE_DIR} OUTPUT_VARIABLE ISMRMRD_GIT_SHA1 ERROR_VARIABLE ISMRMRD_GIT_STDERR)
    string(STRIP "${ISMRMRD_GIT_SHA1}" ISMRMRD_GIT_SHA1)
    string(LENGTH "${ISMRMRD_GIT_SHA1}" ISMRMRD_GIT_SHA1_LEN)
    if (${ISMRMRD_GIT_SHA1_LEN} LESS 40)
        message(WARNING "Could not determine SHA-1 hash: ${ISMRMRD_GIT_STDERR}")
        set(ISMRMRD_GIT_SHA1 "NA")
    endif ()
else()
  set(ISMRMRD_GIT_SHA1 "NA")
endif()
configure_file(include/version.in ${CMAKE_BINARY_DIR}/include/ismrmrd/version.h)
install(FILES ${CMAKE_BINARY_DIR}/include/ismrmrd/version.h DESTINATION include/ismrmrd COMPONENT Devel)
# note: for the utilities in this project that need ismrmrd/version.h
# remember to add ${CMAKE_BINARY_DIR}/include to the include path


#  ---   VERSIONING  (end) ----

#  ---   Main Library  (begin) ----
# in windows, install the HDF5 dependencies
if (HDF5_FOUND AND WIN32 AND ISMRMRD_INSTALL_DEPENDENCIES)
    if(DEFINED ENV{HDF5_ROOT})
        set(HDF5_BIN_DIR $ENV{HDF5_ROOT}/bin)
    else ()
        set(HDF5_BIN_DIR ${HDF5_C_INCLUDE_DIR}/../bin)
    endif ()
    message("Install hdf5 libraries from ${HDF5_BIN_DIR} ")
    install( DIRECTORY ${HDF5_BIN_DIR} DESTINATION bin/.. FILES_MATCHING PATTERN "*.dll" )
endif ()

# include directories for main library
set(ISMRMRD_TARGET_INCLUDE_DIRS
  ${CMAKE_CURRENT_LIST_DIR}/include
  ${CMAKE_BINARY_DIR}/include
  ${ISMRMRD_DATASET_INCLUDE_DIR}
)

set(ISMRMRD_TARGET_SOURCES
  libsrc/ismrmrd.c
  libsrc/ismrmrd.cpp
  libsrc/xml.cpp
  libsrc/meta.cpp
  ${ISMRMRD_DATASET_SOURCES}
)

set(ISMRMRD_TARGET_LINK_LIBS ${ISMRMRD_DATASET_LIBRARIES})

# optional handling of system-installed pugixml
if(USE_SYSTEM_PUGIXML)
  find_package(PugiXML)
  if(PugiXML_FOUND)
    message("Found system pugixml: ${PugiXML_INCLUDE_DIR} ${PugiXML_LIBRARY}")
    list(APPEND ISMRMRD_TARGET_INCLUDE_DIRS ${PugiXML_INCLUDE_DIR})
    list(APPEND ISMRMRD_TARGET_LINK_LIBS ${PugiXML_LIBRARY})
  else()
    message(FATAL_ERROR "Pugixml library not found on the system, try without "
    "setting USE_SYSTEM_PUGIXML to use the version provided in the source "
    "tree.")
  endif()
  list(APPEND ISMRMRD_TARGET_INCLUDE_DIRS ${PugiXML_INCLUDE_DIR})
  list(APPEND ISMRMRD_TARGET_LINK_LIBS ${PugiXML_LIBRARY})
else()
  list(APPEND ISMRMRD_TARGET_SOURCES libsrc/pugixml.cpp)
endif()

# main library
include_directories(${ISMRMRD_TARGET_INCLUDE_DIRS})
add_library(ismrmrd SHARED ${ISMRMRD_TARGET_SOURCES})
set_target_properties(ismrmrd PROPERTIES
  VERSION ${ISMRMRD_VERSION_STRING}
  SOVERSION ${ISMRMRD_SOVERSION}
)
target_link_libraries(ismrmrd ${ISMRMRD_TARGET_LINK_LIBS})
list(APPEND ISMRMRD_LIBRARIES ismrmrd) # Add to list of libraries to be found
list(APPEND ISMRMRD_LIBRARY_DIRS ${CMAKE_BINARY_DIR} ) # Add to list of directories to find libaries

# install the main library
install(TARGETS ismrmrd EXPORT ISMRMRDTargets
   LIBRARY DESTINATION lib
   ARCHIVE DESTINATION lib
   RUNTIME DESTINATION bin
   COMPONENT Devel
)

# install the headers
install(DIRECTORY include/ismrmrd  DESTINATION include COMPONENT Devel)

# install the schema file
install(FILES schema/ismrmrd.xsd DESTINATION share/ismrmrd/schema COMPONENT Devel)

# install the cmake modules
install(FILES cmake/FindFFTW3.cmake DESTINATION share/ismrmrd/cmake COMPONENT Devel)

#  ---   Main Library  (end) ----

# process subdirectories
add_subdirectory(doc)

add_subdirectory(utilities)
if (HDF5_FOUND)
    add_subdirectory(examples/c)
endif ()

# TODO: make this work on Windows
if (NOT WIN32)
    add_subdirectory(tests)
endif ()

# install the matlab api
install(DIRECTORY matlab DESTINATION share/ismrmrd )

#--- Create cmake package for downstream projects
#
##- include(CMakePackageConfigHelpers)
##- write_basic_package_version_file(
##-   "${CMAKE_CURRENT_BINARY_DIR}/ISMRMRDConfigVersion.cmake"
##-   VERSION ${ISMRMRD_VERSION_STRING}
##-   COMPATIBILITY AnyNewerVersion
##- )

##- export(EXPORT ISMRMRDTargets
##-  FILE "${CMAKE_CURRENT_BINARY_DIR}/ISMRMRDTargets.cmake"
##-  NAMESPACE ISMRMRD
##-)

set(CONFIG_ISMRMRD_SCHEMA_DIR   ${ISMRMRD_SCHEMA_DIR})
set(CONFIG_ISMRMRD_TARGET_INCLUDE_DIRS ${ISMRMRD_TARGET_INCLUDE_DIRS})
set(CONFIG_ISMRMRD_LIBRARY_DIRS ${ISMRMRD_LIBRARY_DIRS})
configure_file(cmake/ISMRMRDConfig.cmake.in
  "${CMAKE_CURRENT_BINARY_DIR}/ISMRMRDConfig.cmake"
  @ONLY
)

set(CONFIG_ISMRMRD_SCHEMA_DIR   ${CMAKE_INSTALL_PREFIX}/share/ismrmrd/schema)
set(CONFIG_ISMRMRD_TARGET_INCLUDE_DIRS ${CMAKE_INSTALL_PREFIX}/include)
set(CONFIG_ISMRMRD_LIBRARY_DIRS ${CMAKE_INSTALL_PREFIX}/lib)
configure_file(cmake/ISMRMRDConfig.cmake.in
  "${CMAKE_CURRENT_BINARY_DIR}/InstallFiles/ISMRMRDConfig.cmake"
  @ONLY
)

set(ConfigPackageLocation lib/cmake/ISMRMRD)
install(
  FILES
    "${CMAKE_CURRENT_BINARY_DIR}/InstallFiles/ISMRMRDConfig.cmake"
#--    "${CMAKE_CURRENT_BINARY_DIR}/ISMRMRDConfigVersion.cmake"
  DESTINATION
    ${ConfigPackageLocation}
  COMPONENT
    Devel
)

# Create package
string(TOLOWER ${PROJECT_NAME} PROJECT_NAME_LOWER)
include(${ISMRMRD_CMAKE_DIR}/ismrmrd_cpack.cmake)
if(CPACK_GENERATOR)
  message(STATUS "Found CPack generators: ${CPACK_GENERATOR}")
  configure_file("${ISMRMRD_CMAKE_DIR}/cpack_options.cmake.in" ${ISMRMRD_CPACK_CFG_FILE} @ONLY)
  set(CPACK_PROJECT_CONFIG_FILE ${ISMRMRD_CPACK_CFG_FILE})
  include(CPack)
endif()

=== examples/c/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)
project(ISMRMRD-C-EXAMPLE)

# if building this example as a standalone project
if(CMAKE_SOURCE_DIR STREQUAL CMAKE_CURRENT_SOURCE_DIR)
    if(NOT DEFINED ENV{ISMRMRD_HOME})
        message(FATAL_ERROR "ISMRMRD_HOME environment variable must be defined")
    endif()

    list(APPEND CMAKE_MODULE_PATH "$ENV{ISMRMRD_HOME}/share/ismrmrd/cmake")

    find_package(Ismrmrd REQUIRED)

# otherwise, building it as part of ISMRMRD itself
else()
    set(ISMRMRD_INCLUDE_DIR "${CMAKE_SOURCE_DIR}/include ${CMAKE_BINARY_DIR}/include")
    set(ISMRMRD_LIBRARIES ismrmrd)
endif()

include_directories(${ISMRMRD_INCLUDE_DIR})
add_executable(ismrmrd_c_example main.c)
target_link_libraries(ismrmrd_c_example ${ISMRMRD_LIBRARIES})
install(TARGETS ismrmrd_c_example DESTINATION bin)

=== debian/changelog ===
ismrmrd (1.3.3-1build2) bionic; urgency=medium

  * No-change rebuild for boost soname change.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 26 Oct 2017 17:16:56 +0000

ismrmrd (1.3.3-1build1) zesty; urgency=medium

  * Rebuild against new hdf5

 -- Iain Lane <iain@orangesquash.org.uk>  Tue, 29 Nov 2016 17:34:29 +0000

ismrmrd (1.3.3-1) unstable; urgency=medium

  * New upstream version 1.3.3
  * Update patch queue.
    - Drop Explicit-64-bit-shifts-for-flags.patch, applied upstream.
    - Refresh Fix-HDF5-detection-with-CMake-3.6.patch.
    - Refresh Use-Debian-CMake-find-module-location.patch.
    - Drop hdf5-1.10.patch, applied upstream.
  * Fix usability of ISMRMRD CMake packaging.
    - New patch Fix-CMake-package-configuration.patch.
    - New patch Fix-CMake-package-detection.patch.
    - Drop Use-Debian-CMake-find-module-location.patch, no longer required.
    - Install CMake configuration to -dev package.
  * Upgrade packaging to debhelper 10.
  * Drop superfluous Testsuite field.
  * Simplify the packaging testsuite.
  * Enable multiarch installation of binaries.
    - New patch Add-support-for-multiarch.patch.
    - Update install paths of lib and dev packages.
    - Add Multi-Arch fields to all binary packages.
  * Keep doxygen generated instance of jQuery.
  * Miscellaneous changes to control file:
    - Replace build dependency on libhdf5-serial-dev with libhdf5-dev.
    - Add missing install dependency on libhdf5-dev for the -dev package.
  * Miscellaneous changes to rules file:
    - Disable verbosity by default.
    - Reformat content of dh_auto_build override.

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Sat, 26 Nov 2016 11:45:27 +0000

ismrmrd (1.3.2-4.1) unstable; urgency=medium

  * Non-maintainer upload
  * New patch to support HDF5 1.10 (closes: #841959)

 -- Gilles Filippini <pini@debian.org>  Sun, 30 Oct 2016 17:54:19 +0100

=== debian/control ===
Source: ismrmrd
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Ghislain Antony Vaillant <ghisvail@gmail.com>
Section: science
Priority: optional
Build-Depends: cmake,
               debhelper (>= 10),
               libboost-program-options-dev,
               libboost-test-dev,
               libfftw3-dev,
               libhdf5-dev,
               libpugixml-dev
Build-Depends-Indep: doxygen
Standards-Version: 3.9.8
Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/ismrmrd.git
Vcs-Git: https://anonscm.debian.org/git/debian-med/ismrmrd.git
Homepage: http://ismrmrd.github.io/

Package: libismrmrd1.3
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: ISMRM Raw Data format (ISMRMRD)
 The ISMRMRD format combines a mix of flexible data structures (XML header) 
 and fixed structures (equivalent to C-structs) to represent MRI data.
 .
 In addition, the ISMRMRD format also specifies an image header for storing 
 reconstructed images and the accompanying C++ library provides a convenient 
 way of writing such images into HDF5 files along with generic arrays for 
 storing less well defined data structures, e.g. coil sensitivity maps or 
 other calibration data.
 .
 This package provides the shared library.

Package: libismrmrd-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: ${misc:Depends},
         libhdf5-dev,
         libismrmrd1.3 (= ${binary:Version})
Suggests: libismrmrd-doc
Description: development files for ISMRMRD
 The ISMRMRD format combines a mix of flexible data structures (XML header) 
 and fixed structures (equivalent to C-structs) to represent MRI data.
 .
 In addition, the ISMRMRD format also specifies an image header for storing 
 reconstructed images and the accompanying C++ library provides a convenient 
 way of writing such images into HDF5 files along with generic arrays for 
 storing less well defined data structures, e.g. coil sensitivity maps or 
 other calibration data.
 .
 This package provides the development files.

Package: libismrmrd-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends}
Description: documentation for ISMRMRD
 The ISMRMRD format combines a mix of flexible data structures (XML header) 
 and fixed structures (equivalent to C-structs) to represent MRI data.
 .
 In addition, the ISMRMRD format also specifies an image header for storing 
 reconstructed images and the accompanying C++ library provides a convenient 
 way of writing such images into HDF5 files along with generic arrays for 
 storing less well defined data structures, e.g. coil sensitivity maps or 
 other calibration data.
 .
 This package provides the documentation.

Package: ismrmrd-tools
Architecture: any
Multi-Arch: foreign
Section: utils
Depends: ${misc:Depends},
         ${shlibs:Depends},
         ismrmrd-schema
Description: command-line tools for ISMRMRD
 The ISMRMRD format combines a mix of flexible data structures (XML header) 
 and fixed structures (equivalent to C-structs) to represent MRI data.
 .
 In addition, the ISMRMRD format also specifies an image header for storing 
 reconstructed images and the accompanying C++ library provides a convenient 
 way of writing such images into HDF5 files along with generic arrays for 
 storing less well defined data structures, e.g. coil sensitivity maps or 
 other calibration data.
 .
 This package provides the command-line tools.

Package: ismrmrd-schema
Architecture: all
Multi-Arch: foreign
Section: misc
Depends: ${misc:Depends}
Description: schema for ISMRMRD
 The ISMRMRD format combines a mix of flexible data structures (XML header) 
 and fixed structures (equivalent to C-structs) to represent MRI data.
 .
 In addition, the ISMRMRD format also specifies an image header for storing 
 reconstructed images and the accompanying C++ library provides a convenient 
 way of writing such images into HDF5 files along with generic arrays for 
 storing less well defined data structures, e.g. coil sensitivity maps or 
 other calibration data.
 .
 This package provides the XML schema.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# Hardening flags.
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND = -Wall -pedantic
export DEB_CXXFLAGS_MAINT_APPEND = -Wall -pedantic
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DUSE_SYSTEM_PUGIXML=ON

override_dh_auto_build-indep:
	dh_auto_build -- apidoc

override_dh_auto_installdocs-indep:
	dh_installdocs --indep
	dh_doxygen --indep

override_dh_compress:
	dh_compress --exclude=examples

=== debian/tests/control ===
Test-Command: cd $AUTOPKGTEST_TMP
 ; cmake /usr/share/doc/libismrmrd-doc/examples/c/
 ; make -j$(nproc)
 ; ./ismrmrd_c_example
Depends: @, cmake, g++ | c++-compiler
Restrictions: allow-stderr

=== debian/watch ===
version=3
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/ismrmrd-$1\.tar\.gz/ \
  https://github.com/ismrmrd/ismrmrd/tags .*/v?(\d\S*)\.tar\.gz

## ismrmrd 1.4.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -49,7 +49,7 @@
     add_definitions(-D__func__=__FUNCTION__)
 else ()
     set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=c99 -Wall")
-    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall")
+    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -std=c++11")
 endif ()
 
 #  ---   VERSIONING  (begin) ----
@@ -63,12 +63,12 @@
 #in the utility libraries, that don't affect the data format itself.
 # For more information see http://semver.org/
 set(ISMRMRD_VERSION_MAJOR 1)
-set(ISMRMRD_VERSION_MINOR 3)
-set(ISMRMRD_VERSION_PATCH 3)
+set(ISMRMRD_VERSION_MINOR 4)
+set(ISMRMRD_VERSION_PATCH 0)
 set(ISMRMRD_VERSION_STRING ${ISMRMRD_VERSION_MAJOR}.${ISMRMRD_VERSION_MINOR}.${ISMRMRD_VERSION_PATCH})
 set(ISMRMRD_SOVERSION ${ISMRMRD_VERSION_MAJOR}.${ISMRMRD_VERSION_MINOR})
 
-set(ISMRMRD_XML_SCHEMA_SHA1 "9b899c6ad806bc2388c70461d6e5affe5cc6d750")
+set(ISMRMRD_XML_SCHEMA_SHA1 "275129288d0c5ec39ee11bf8f78f952ae1dcec76")
 
 #Remove line breaks and white space that does not change the meaning of the schema
 file(STRINGS ${CMAKE_SOURCE_DIR}/schema/ismrmrd.xsd SCHEMA_STRINGS) #Read all strings from file
@@ -106,13 +106,15 @@
 
 
 # Find HDF5 for dataset support
-find_package(HDF5 1.8 COMPONENTS C)
+find_package(HDF5 COMPONENTS C)
 
 if (HDF5_FOUND)
     set (ISMRMRD_DATASET_SUPPORT true)
     set (ISMRMRD_DATASET_SOURCES libsrc/dataset.c libsrc/dataset.cpp)
-    set (ISMRMRD_DATASET_INCLUDE_DIR ${HDF5_C_INCLUDE_DIR})
+    set (ISMRMRD_DATASET_INCLUDE_DIR ${HDF5_INCLUDE_DIRS})
     set (ISMRMRD_DATASET_LIBRARIES ${HDF5_LIBRARIES})
+    add_definitions(${HDF5_DEFINITIONS})
+	include_directories(${HDF5_INCLUDE_DIRS})
 else ()
     set (ISMRMRD_DATASET_SUPPORT false)
     message (WARNING "HDF5 not found. Dataset and file support unavailable!")
@@ -164,6 +166,8 @@
   libsrc/ismrmrd.cpp
   libsrc/xml.cpp
   libsrc/meta.cpp
+  libsrc/waveform.cpp
+  libsrc/waveform.c
   ${ISMRMRD_DATASET_SOURCES}
 )
 
@@ -196,7 +200,7 @@
 )
 target_link_libraries(ismrmrd ${ISMRMRD_TARGET_LINK_LIBS})
 list(APPEND ISMRMRD_LIBRARIES ismrmrd) # Add to list of libraries to be found
-list(APPEND ISMRMRD_LIBRARY_DIRS ${CMAKE_BINARY_DIR} ) # Add to list of directories to find libaries
+list(APPEND ISMRMRD_LIBRARY_DIRS ${CMAKE_BINARY_DIR} ) # Add to list of directories to find libraries
 
 # install the main library
 install(TARGETS ismrmrd EXPORT ISMRMRDTargets
@@ -258,6 +262,11 @@
 set(CONFIG_ISMRMRD_SCHEMA_DIR   ${CMAKE_INSTALL_PREFIX}/share/ismrmrd/schema)
 set(CONFIG_ISMRMRD_TARGET_INCLUDE_DIRS ${CMAKE_INSTALL_PREFIX}/include)
 set(CONFIG_ISMRMRD_LIBRARY_DIRS ${CMAKE_INSTALL_PREFIX}/lib)
+if (ISMRMRD_DATASET_SUPPORT)
+  list(APPEND CONFIG_ISMRMRD_TARGET_INCLUDE_DIRS ${HDF5_INCLUDE_DIRS})
+  list(APPEND CONFIG_ISMRMRD_LIBRARY_DIRS ${HDF5_LIBRARY_DIRS})
+  list(APPEND ISMRMRD_LIBRARIES ${HDF5_LIBRARIES})
+endif ()
 configure_file(cmake/ISMRMRDConfig.cmake.in
   "${CMAKE_CURRENT_BINARY_DIR}/InstallFiles/ISMRMRDConfig.cmake"
   @ONLY
@@ -274,6 +283,15 @@
     Devel
 )
 
+install(
+  FILES
+    cmake/FindFFTW3.cmake
+  DESTINATION
+    ${ConfigPackageLocation}
+  COMPONENT
+    Devel
+)
+  
 # Create package
 string(TOLOWER ${PROJECT_NAME} PROJECT_NAME_LOWER)
 include(${ISMRMRD_CMAKE_DIR}/ismrmrd_cpack.cmake)

=== doc/CMakeLists.txt ===
add_custom_target(doc)
find_package(Doxygen)
if(DOXYGEN_FOUND)
    set(API_DOC_DIR ${CMAKE_CURRENT_BINARY_DIR}/html/api)
    set(DOXYFILE ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile)

    configure_file(${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in ${DOXYFILE} @ONLY)

    add_custom_target(apidoc
        COMMAND ${CMAKE_COMMAND} -E make_directory ${API_DOC_DIR}
        COMMAND ${DOXYGEN_EXECUTABLE} ${DOXYFILE}
        COMMENT "Generating API documentation using Doxygen" VERBATIM)
    add_dependencies(doc apidoc)
else()
    message(STATUS "Doxygen not found. Not able to build API documentation")
endif()

find_program(SPHINXBUILD sphinx-build)
if(SPHINXBUILD)
    if(WIN32)
        set(SPHINX_MAKEBAT ${CMAKE_CURRENT_BINARY_DIR}/make.sphinx.bat)
        configure_file(make.sphinx.bat.in ${SPHINX_MAKEBAT} @ONLY)
        add_custom_target(htmldoc
            COMMAND ${SPHINX_MAKEBAT} html
            COMMAND ${CMAKE_COMMAND} -E touch ${CMAKE_CURRENT_BINARY_DIR}/html/.nojekyll
            COMMENT "Generating HTML docs using Sphinx" VERBATIM)
    else()
        set(SPHINX_MAKEFILE ${CMAKE_CURRENT_BINARY_DIR}/Makefile.sphinx)
        configure_file(Makefile.sphinx.in ${SPHINX_MAKEFILE} @ONLY)
        add_custom_target(htmldoc
            COMMAND make -f ${SPHINX_MAKEFILE} html
            COMMAND ${CMAKE_COMMAND} -E touch ${CMAKE_CURRENT_BINARY_DIR}/html/.nojekyll
            COMMENT "Generating HTML docs using Sphinx" VERBATIM)
    endif()
    add_dependencies(doc htmldoc)
else()
    message(STATUS "sphinx-build not found. Not able to build HTML project documentation")
endif()

=== tests/CMakeLists.txt ===
find_package(Boost 1.43 COMPONENTS unit_test_framework)

if (NOT Boost_UNIT_TEST_FRAMEWORK_FOUND)
    message("Boost Unit Test Framework not found. Not compiling tests")
    return()
endif ()

include_directories(${CMAKE_SOURCE_DIR}/include ${CMAKE_BINARY_DIR}/include ${Boost_INCLUDE_DIR})

add_executable(test_ismrmrd
    test_main.cpp
    test_acquisitions.cpp
    test_images.cpp
    test_ndarray.cpp
    test_flags.cpp
    test_channels.cpp
    test_quaternions.cpp)

target_link_libraries(test_ismrmrd ismrmrd ${Boost_LIBRARIES})

add_custom_target(check COMMAND ${CMAKE_CURRENT_BINARY_DIR}/test_ismrmrd DEPENDS test_ismrmrd)

=== utilities/CMakeLists.txt ===
# Build the info application
message("Building info application")
include_directories(${CMAKE_BINARY_DIR}/include
                    ${CMAKE_SOURCE_DIR}/include
		    ${CMAKE_SOURCE_DIR}/libsrc)

add_executable(ismrmrd_info ismrmrd_info.cpp)
target_link_libraries(ismrmrd_info ismrmrd)
install(TARGETS ismrmrd_info DESTINATION bin)

if (NOT WIN32)
  add_executable(ismrmrd_test_xml
    ismrmrd_test_xml.cpp
    ${CMAKE_SOURCE_DIR}/libsrc/pugixml.cpp )
  target_link_libraries(ismrmrd_test_xml ismrmrd)
  install(TARGETS ismrmrd_test_xml DESTINATION bin)
endif()

if (HDF5_FOUND)
    add_executable(ismrmrd_read_timing_test read_timing_test.cpp)
    target_link_libraries(ismrmrd_read_timing_test ismrmrd)
    install(TARGETS ismrmrd_read_timing_test DESTINATION bin)

    find_package(Boost 1.43 COMPONENTS program_options)
    find_package(FFTW3 COMPONENTS single)

    if(FFTW3_FOUND AND Boost_FOUND)
        message("FFTW3 and Boost Found... building utilities")

        if(WIN32)
            link_directories(${Boost_LIBRARY_DIRS})
        endif()

        include_directories(
            ${CMAKE_SOURCE_DIR/include}
            ${Boost_INCLUDE_DIR}
            ${FFTW3_INCLUDE_DIR})

        # Shepp-Logan phantom
        add_executable(ismrmrd_generate_cartesian_shepp_logan
            generate_cartesian_shepp_logan.cpp
            ismrmrd_phantom.cpp)
        if(WIN32)
            target_link_libraries( ismrmrd_generate_cartesian_shepp_logan
                ismrmrd
                ${FFTW3_LIBRARIES})
        else()
            target_link_libraries( ismrmrd_generate_cartesian_shepp_logan
                ismrmrd
                ${Boost_PROGRAM_OPTIONS_LIBRARY}
                ${FFTW3_LIBRARIES})
        endif()
        install(TARGETS ismrmrd_generate_cartesian_shepp_logan DESTINATION bin)

        # Shepp-Logan phantom
        add_executable(ismrmrd_recon_cartesian_2d
            recon_cartesian_2d.cpp)
        if(WIN32)
            target_link_libraries( ismrmrd_recon_cartesian_2d
                ismrmrd
                ${FFTW3_LIBRARIES})
        else()
            target_link_libraries( ismrmrd_recon_cartesian_2d
                ismrmrd
                ${Boost_PROGRAM_OPTIONS_LIBRARY}
                ${FFTW3_LIBRARIES})
        endif()
        install(TARGETS ismrmrd_recon_cartesian_2d DESTINATION bin)

    else()
        message("FFTW3 or Boost NOT Found, cannot build utilities")
    endif()
else ()
    message("HDF5 NOT Found, cannot build utilities")
endif ()

=== debian/changelog ===
ismrmrd (1.4.0-1build1) focal; urgency=medium

  * No change rebuild against new boost1.71 ABI

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 03 Feb 2020 20:37:02 +0000

ismrmrd (1.4.0-1) unstable; urgency=medium

  * Team upload.
  * New upstream version
  * debhelper 12
  * Standards-Version: 4.3.0

 -- Andreas Tille <tille@debian.org>  Sat, 26 Jan 2019 08:23:41 +0100

ismrmrd (1.3.3-3) unstable; urgency=medium

  * Team upload.
  * Fix dir in autopkgtest
    Closes: #904110

 -- Andreas Tille <tille@debian.org>  Fri, 20 Jul 2018 06:01:08 +0200

ismrmrd (1.3.3-2) unstable; urgency=medium

  * Team upload.
  * debhelper 11 (adapt doc-base file to new location of docs)
  * Point Vcs fields to salsa.debian.org
  * Standards-Version: 4.1.5

 -- Andreas Tille <tille@debian.org>  Wed, 18 Jul 2018 09:30:27 +0200

=== debian/control ===
--- 
+++ 
@@ -1,19 +1,20 @@
 Source: ismrmrd
-Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
 Uploaders: Ghislain Antony Vaillant <ghisvail@gmail.com>
 Section: science
 Priority: optional
 Build-Depends: cmake,
-               debhelper (>= 10),
+               debhelper (>= 12~),
                libboost-program-options-dev,
                libboost-test-dev,
                libfftw3-dev,
                libhdf5-dev,
                libpugixml-dev
 Build-Depends-Indep: doxygen
-Standards-Version: 3.9.8
-Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/ismrmrd.git
-Vcs-Git: https://anonscm.debian.org/git/debian-med/ismrmrd.git
+Standards-Version: 4.3.0
+Vcs-Browser: https://salsa.debian.org/med-team/ismrmrd
+Vcs-Git: https://salsa.debian.org/med-team/ismrmrd.git
 Homepage: http://ismrmrd.github.io/
 
 Package: libismrmrd1.3

## ismrmrd 1.4.2.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 2.8)
+cmake_minimum_required(VERSION 2.8.12)
 foreach(p
     CMP0025 # CMake 3.0 Compiler id for Apple Clang is now ``AppleClang``.
     CMP0042 # CMake 3.0 ``MACOSX_RPATH`` is enabled by default.
@@ -19,14 +19,14 @@
 
 # command line options
 option(USE_SYSTEM_PUGIXML "Use pugixml installed on the system" OFF)
+option(USE_HDF5_DATASET_SUPPORT "Compile with support for reading and writing datasets to HDF5 files" ON)
+option(BUILD_TESTS "Build unit tests " ON)
+option(BUILD_UTILITIES "Build utilities tests " ON)
+option(BUILD_EXAMPLES "Build examples tests " ON)
 
 # and include it to the search list
 list(APPEND CMAKE_MODULE_PATH ${ISMRMRD_CMAKE_DIR})
 
-# whether to install dependencies
-if (WIN32)
-    option(ISMRMRD_INSTALL_DEPENDENCIES "Install ismrmrd dependencies in windows" Off)
-endif ()
 
 # set the build type to Release if not specified
 if(NOT CMAKE_BUILD_TYPE)
@@ -64,7 +64,7 @@
 # For more information see http://semver.org/
 set(ISMRMRD_VERSION_MAJOR 1)
 set(ISMRMRD_VERSION_MINOR 4)
-set(ISMRMRD_VERSION_PATCH 0)
+set(ISMRMRD_VERSION_PATCH 2)
 set(ISMRMRD_VERSION_STRING ${ISMRMRD_VERSION_MAJOR}.${ISMRMRD_VERSION_MINOR}.${ISMRMRD_VERSION_PATCH})
 set(ISMRMRD_SOVERSION ${ISMRMRD_VERSION_MAJOR}.${ISMRMRD_VERSION_MINOR})
 
@@ -106,18 +106,27 @@
 
 
 # Find HDF5 for dataset support
-find_package(HDF5 COMPONENTS C)
-
-if (HDF5_FOUND)
-    set (ISMRMRD_DATASET_SUPPORT true)
-    set (ISMRMRD_DATASET_SOURCES libsrc/dataset.c libsrc/dataset.cpp)
-    set (ISMRMRD_DATASET_INCLUDE_DIR ${HDF5_INCLUDE_DIRS})
-    set (ISMRMRD_DATASET_LIBRARIES ${HDF5_LIBRARIES})
+
+
+if (USE_HDF5_DATASET_SUPPORT)
+    if (VCPKG_TARGET_TRIPLET) #VCPKG HDF5 is packaged differently.
+        find_package(HDF5 CONFIG COMPONENTS C shared REQUIRED)
+        set(HDF5_C_LIBRARIES hdf5::hdf5-shared)
+    else ()
+        find_package(HDF5 COMPONENTS C REQUIRED)
+    endif ()
+    set(ISMRMRD_DATASET_SUPPORT true)
+    set(ISMRMRD_DATASET_SOURCES libsrc/dataset.c libsrc/dataset.cpp)
+    set(ISMRMRD_DATASET_INCLUDE_DIR ${HDF5_INCLUDE_DIRS})
+    set(ISMRMRD_DATASET_LIBRARIES ${HDF5_C_LIBRARIES})
     add_definitions(${HDF5_DEFINITIONS})
-	include_directories(${HDF5_INCLUDE_DIRS})
+    include_directories(${HDF5_INCLUDE_DIRS})
+    message("HDF5 found at: ${HDF5_INCLUDE_DIR}")
+    message("HDF5 found at: ${HDF5_C_LIBRARIES}")
+
 else ()
-    set (ISMRMRD_DATASET_SUPPORT false)
-    message (WARNING "HDF5 not found. Dataset and file support unavailable!")
+    set(ISMRMRD_DATASET_SUPPORT false)
+    message(WARNING " Dataset and file support unavailable!")
 endif ()
 
 # Generate the version.h header file
@@ -144,15 +153,6 @@
 
 #  ---   Main Library  (begin) ----
 # in windows, install the HDF5 dependencies
-if (HDF5_FOUND AND WIN32 AND ISMRMRD_INSTALL_DEPENDENCIES)
-    if(DEFINED ENV{HDF5_ROOT})
-        set(HDF5_BIN_DIR $ENV{HDF5_ROOT}/bin)
-    else ()
-        set(HDF5_BIN_DIR ${HDF5_C_INCLUDE_DIR}/../bin)
-    endif ()
-    message("Install hdf5 libraries from ${HDF5_BIN_DIR} ")
-    install( DIRECTORY ${HDF5_BIN_DIR} DESTINATION bin/.. FILES_MATCHING PATTERN "*.dll" )
-endif ()
 
 # include directories for main library
 set(ISMRMRD_TARGET_INCLUDE_DIRS
@@ -174,30 +174,38 @@
 set(ISMRMRD_TARGET_LINK_LIBS ${ISMRMRD_DATASET_LIBRARIES})
 
 # optional handling of system-installed pugixml
-if(USE_SYSTEM_PUGIXML)
-  find_package(PugiXML)
-  if(PugiXML_FOUND)
-    message("Found system pugixml: ${PugiXML_INCLUDE_DIR} ${PugiXML_LIBRARY}")
-    list(APPEND ISMRMRD_TARGET_INCLUDE_DIRS ${PugiXML_INCLUDE_DIR})
-    list(APPEND ISMRMRD_TARGET_LINK_LIBS ${PugiXML_LIBRARY})
-  else()
-    message(FATAL_ERROR "Pugixml library not found on the system, try without "
-    "setting USE_SYSTEM_PUGIXML to use the version provided in the source "
-    "tree.")
-  endif()
-  list(APPEND ISMRMRD_TARGET_INCLUDE_DIRS ${PugiXML_INCLUDE_DIR})
-  list(APPEND ISMRMRD_TARGET_LINK_LIBS ${PugiXML_LIBRARY})
-else()
-  list(APPEND ISMRMRD_TARGET_SOURCES libsrc/pugixml.cpp)
-endif()
+if (USE_SYSTEM_PUGIXML)
+
+    if (VCPKG_TARGET_TRIPLET) #VCPKG .
+        find_package(PugiXML CONFIG REQUIRED)
+        list(APPEND ISMRMRD_TARGET_LINK_LIBS pugixml)
+    else ()
+        find_package(PugiXML REQUIRED)
+
+        message("Found system pugixml: ${PugiXML_INCLUDE_DIR} ${PugiXML_LIBRARY}")
+        list(APPEND ISMRMRD_TARGET_INCLUDE_DIRS ${PugiXML_INCLUDE_DIR})
+        list(APPEND ISMRMRD_TARGET_LINK_LIBS ${PugiXML_LIBRARY})
+        list(APPEND ISMRMRD_TARGET_INCLUDE_DIRS ${PugiXML_INCLUDE_DIR})
+        list(APPEND ISMRMRD_TARGET_LINK_LIBS ${PugiXML_LIBRARY})
+    endif ()
+else ()
+    list(APPEND ISMRMRD_TARGET_SOURCES libsrc/pugixml.cpp)
+endif ()
 
 # main library
 include_directories(${ISMRMRD_TARGET_INCLUDE_DIRS})
 add_library(ismrmrd SHARED ${ISMRMRD_TARGET_SOURCES})
+add_library(ismrmrd::ismrmrd ALIAS ismrmrd)
 set_target_properties(ismrmrd PROPERTIES
   VERSION ${ISMRMRD_VERSION_STRING}
   SOVERSION ${ISMRMRD_SOVERSION}
 )
+
+set_target_properties(ismrmrd
+  PROPERTIES
+  EXPORT_NAME ISMRMRD
+  INTERFACE_INCLUDE_DIRECTORIES $<INSTALL_INTERFACE:include>)
+
 target_link_libraries(ismrmrd ${ISMRMRD_TARGET_LINK_LIBS})
 list(APPEND ISMRMRD_LIBRARIES ismrmrd) # Add to list of libraries to be found
 list(APPEND ISMRMRD_LIBRARY_DIRS ${CMAKE_BINARY_DIR} ) # Add to list of directories to find libraries
@@ -224,13 +232,17 @@
 # process subdirectories
 add_subdirectory(doc)
 
-add_subdirectory(utilities)
-if (HDF5_FOUND)
+if (BUILD_UTILITIES)
+  add_subdirectory(utilities)
+endif()
+
+
+if (HDF5_FOUND AND BUILD_EXAMPLES)
     add_subdirectory(examples/c)
 endif ()
 
 # TODO: make this work on Windows
-if (NOT WIN32)
+if (BUILD_TESTS)
     add_subdirectory(tests)
 endif ()
 
@@ -239,17 +251,9 @@
 
 #--- Create cmake package for downstream projects
 #
-##- include(CMakePackageConfigHelpers)
-##- write_basic_package_version_file(
-##-   "${CMAKE_CURRENT_BINARY_DIR}/ISMRMRDConfigVersion.cmake"
-##-   VERSION ${ISMRMRD_VERSION_STRING}
-##-   COMPATIBILITY AnyNewerVersion
-##- )
-
-##- export(EXPORT ISMRMRDTargets
-##-  FILE "${CMAKE_CURRENT_BINARY_DIR}/ISMRMRDTargets.cmake"
-##-  NAMESPACE ISMRMRD
-##-)
+
+include(CMakePackageConfigHelpers)
+set(INSTALL_CONFIGDIR lib/cmake/ISMRMRD)
 
 set(CONFIG_ISMRMRD_SCHEMA_DIR   ${ISMRMRD_SCHEMA_DIR})
 set(CONFIG_ISMRMRD_TARGET_INCLUDE_DIRS ${ISMRMRD_TARGET_INCLUDE_DIRS})
@@ -264,34 +268,47 @@
 set(CONFIG_ISMRMRD_LIBRARY_DIRS ${CMAKE_INSTALL_PREFIX}/lib)
 if (ISMRMRD_DATASET_SUPPORT)
   list(APPEND CONFIG_ISMRMRD_TARGET_INCLUDE_DIRS ${HDF5_INCLUDE_DIRS})
-  list(APPEND CONFIG_ISMRMRD_LIBRARY_DIRS ${HDF5_LIBRARY_DIRS})
-  list(APPEND ISMRMRD_LIBRARIES ${HDF5_LIBRARIES})
-endif ()
-configure_file(cmake/ISMRMRDConfig.cmake.in
+endif ()
+
+configure_package_config_file(cmake/ISMRMRDConfig.cmake.in
   "${CMAKE_CURRENT_BINARY_DIR}/InstallFiles/ISMRMRDConfig.cmake"
-  @ONLY
-)
-
-set(ConfigPackageLocation lib/cmake/ISMRMRD)
-install(
-  FILES
-    "${CMAKE_CURRENT_BINARY_DIR}/InstallFiles/ISMRMRDConfig.cmake"
-#--    "${CMAKE_CURRENT_BINARY_DIR}/ISMRMRDConfigVersion.cmake"
-  DESTINATION
-    ${ConfigPackageLocation}
-  COMPONENT
-    Devel
-)
-
-install(
-  FILES
-    cmake/FindFFTW3.cmake
-  DESTINATION
-    ${ConfigPackageLocation}
-  COMPONENT
-    Devel
-)
-  
+  INSTALL_DESTINATION ${INSTALL_CONFIGDIR})
+
+write_basic_package_version_file(
+  "${CMAKE_CURRENT_BINARY_DIR}/ISMRMRDConfigVersion.cmake"
+  VERSION ${ISMRMRD_VERSION_STRING}
+  COMPATIBILITY SameMajorVersion
+  )
+
+# Write a CMake file with all the targets information
+# (not for installing, but for external project to import targets from the
+#  current build tree)
+if(CMAKE_VERSION VERSION_LESS 3.0)
+  export(TARGETS ismrmrd
+    FILE ${CMAKE_CURRENT_BINARY_DIR}/ISMRMRDTargets.cmake
+    NAMESPACE ISMRMRD::
+    )
+else()
+  export(EXPORT ISMRMRDTargets
+    FILE ${CMAKE_CURRENT_BINARY_DIR}/ISMRMRDTargets.cmake
+    NAMESPACE ISMRMRD::
+    )
+endif()
+
+install(EXPORT ISMRMRDTargets
+  FILE ISMRMRDTargets.cmake
+  NAMESPACE ISMRMRD::
+  DESTINATION ${INSTALL_CONFIGDIR}
+  )
+
+install(FILES
+  "${CMAKE_CURRENT_BINARY_DIR}/ISMRMRDConfigVersion.cmake"
+  "${CMAKE_CURRENT_BINARY_DIR}/InstallFiles/ISMRMRDConfig.cmake"
+  DESTINATION ${INSTALL_CONFIGDIR}
+  COMPONENT Devel)
+
+export(PACKAGE ISMRMRD)
+ 
 # Create package
 string(TOLOWER ${PROJECT_NAME} PROJECT_NAME_LOWER)
 include(${ISMRMRD_CMAKE_DIR}/ismrmrd_cpack.cmake)

=== utilities/CMakeLists.txt ===
--- 
+++ 
@@ -40,31 +40,21 @@
         add_executable(ismrmrd_generate_cartesian_shepp_logan
             generate_cartesian_shepp_logan.cpp
             ismrmrd_phantom.cpp)
-        if(WIN32)
-            target_link_libraries( ismrmrd_generate_cartesian_shepp_logan
-                ismrmrd
-                ${FFTW3_LIBRARIES})
-        else()
-            target_link_libraries( ismrmrd_generate_cartesian_shepp_logan
-                ismrmrd
-                ${Boost_PROGRAM_OPTIONS_LIBRARY}
-                ${FFTW3_LIBRARIES})
-        endif()
+        target_link_libraries( ismrmrd_generate_cartesian_shepp_logan
+            ismrmrd
+            ${Boost_PROGRAM_OPTIONS_LIBRARY}
+            ${FFTW3_LIBRARIES})
+        
         install(TARGETS ismrmrd_generate_cartesian_shepp_logan DESTINATION bin)
 
         # Shepp-Logan phantom
         add_executable(ismrmrd_recon_cartesian_2d
             recon_cartesian_2d.cpp)
-        if(WIN32)
-            target_link_libraries( ismrmrd_recon_cartesian_2d
-                ismrmrd
-                ${FFTW3_LIBRARIES})
-        else()
-            target_link_libraries( ismrmrd_recon_cartesian_2d
-                ismrmrd
-                ${Boost_PROGRAM_OPTIONS_LIBRARY}
-                ${FFTW3_LIBRARIES})
-        endif()
+		target_link_libraries( ismrmrd_recon_cartesian_2d
+            ismrmrd
+            ${Boost_PROGRAM_OPTIONS_LIBRARY}
+            ${FFTW3_LIBRARIES})
+
         install(TARGETS ismrmrd_recon_cartesian_2d DESTINATION bin)
 
     else()

=== examples/c/CMakeLists.txt ===
--- 
+++ 
@@ -3,13 +3,7 @@
 
 # if building this example as a standalone project
 if(CMAKE_SOURCE_DIR STREQUAL CMAKE_CURRENT_SOURCE_DIR)
-    if(NOT DEFINED ENV{ISMRMRD_HOME})
-        message(FATAL_ERROR "ISMRMRD_HOME environment variable must be defined")
-    endif()
-
-    list(APPEND CMAKE_MODULE_PATH "$ENV{ISMRMRD_HOME}/share/ismrmrd/cmake")
-
-    find_package(Ismrmrd REQUIRED)
+    find_package(ISMRMRD REQUIRED)
 
 # otherwise, building it as part of ISMRMRD itself
 else()

=== debian/changelog ===
ismrmrd (1.4.2.1-6) unstable; urgency=medium

  * Team upload.
  * debian/patches/167.patch:
    - cherry-pick upstream proposed fix for typo in variable name in cmake
      file making autopkgtest regress with new pugixml 1.11.3

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 22 Dec 2020 15:43:09 +0100

ismrmrd (1.4.2.1-5) unstable; urgency=medium

  * Runtime-depend on libpugixml-dev to fix autopkgtest failure (Closes:
    #974570)
  * Fix arch-all build for real (Closes: #973939).

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 12 Nov 2020 13:09:11 +0100

ismrmrd (1.4.2.1-4) unstable; urgency=medium

  * Team upload.
  * Really fix binary-all FTBFS
    Closes: #973939

 -- Andreas Tille <tille@debian.org>  Thu, 12 Nov 2020 09:40:14 +0100

ismrmrd (1.4.2.1-3) unstable; urgency=medium

  * Team upload.
  * Add missing Breaks+Replaces: libismrmrd1.3 (>= 1.4)
    Closes: #973938, #974045
  * Fix binary-all FTBFS
    Closes: #973939

 -- Andreas Tille <tille@debian.org>  Wed, 11 Nov 2020 11:02:18 +0100

ismrmrd (1.4.2.1-2) unstable; urgency=medium

  * Team upload.
  * Source-only-upload
  * Rename tag

 -- Nilesh Patra <npatra974@gmail.com>  Sat, 07 Nov 2020 22:49:12 +0530

ismrmrd (1.4.2.1-1) unstable; urgency=medium

  [ Nilesh Patra ]
  * Team Upload.
  * New upstream version 1.4.2.1
  * Fix install dirs
  * Don't install useless files
  * Refresh patches
  * Remove travis build status
  * Standards-Version: 4.5.0 (routine-update)
  * debhelper-compat 13 (routine-update)
  * Remove trailing whitespace in debian/changelog (routine-update)
  * Remove trailing whitespace in debian/control (routine-update)
  * Add salsa-ci file (routine-update)
  * Rules-Requires-Root: no (routine-update)
  * Use secure URI in Homepage field.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.

  [ Andreas Tille ]
  * Add static library
  * Use d-shlibs

 -- Nilesh Patra <npatra974@gmail.com>  Sun, 20 Sep 2020 02:35:46 +0530

=== debian/control ===
Source: ismrmrd
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Ghislain Antony Vaillant <ghisvail@gmail.com>
Section: science
Priority: optional
Build-Depends: cmake,
               debhelper-compat (= 13),
               d-shlibs,
               libboost-program-options-dev,
               libboost-test-dev,
               libfftw3-dev,
               libhdf5-dev,
               libpugixml-dev
Build-Depends-Indep: doxygen
Standards-Version: 4.5.0
Vcs-Browser: https://salsa.debian.org/med-team/ismrmrd
Vcs-Git: https://salsa.debian.org/med-team/ismrmrd.git
Homepage: https://ismrmrd.github.io/
Rules-Requires-Root: no

Package: libismrmrd1.4
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Breaks: libismrmrd1.3 (>= 1.4)
Replaces: libismrmrd1.3 (>= 1.4)
Description: ISMRM Raw Data format (ISMRMRD)
 The ISMRMRD format combines a mix of flexible data structures (XML header)
 and fixed structures (equivalent to C-structs) to represent MRI data.
 .
 In addition, the ISMRMRD format also specifies an image header for storing
 reconstructed images and the accompanying C++ library provides a convenient
 way of writing such images into HDF5 files along with generic arrays for
 storing less well defined data structures, e.g. coil sensitivity maps or
 other calibration data.
 .
 This package provides the shared library.

Package: libismrmrd-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: ${misc:Depends},
         libhdf5-dev,
         libpugixml-dev,
         libismrmrd1.4 (= ${binary:Version})
Suggests: libismrmrd-doc
Description: development files for ISMRMRD
 The ISMRMRD format combines a mix of flexible data structures (XML header)
 and fixed structures (equivalent to C-structs) to represent MRI data.
 .
 In addition, the ISMRMRD format also specifies an image header for storing
 reconstructed images and the accompanying C++ library provides a convenient
 way of writing such images into HDF5 files along with generic arrays for
 storing less well defined data structures, e.g. coil sensitivity maps or
 other calibration data.
 .
 This package provides the development files.

Package: libismrmrd-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends}
Description: documentation for ISMRMRD
 The ISMRMRD format combines a mix of flexible data structures (XML header)
 and fixed structures (equivalent to C-structs) to represent MRI data.
 .
 In addition, the ISMRMRD format also specifies an image header for storing
 reconstructed images and the accompanying C++ library provides a convenient
 way of writing such images into HDF5 files along with generic arrays for
 storing less well defined data structures, e.g. coil sensitivity maps or
 other calibration data.
 .
 This package provides the documentation.

Package: ismrmrd-tools
Architecture: any
Multi-Arch: foreign
Section: utils
Depends: ${misc:Depends},
         ${shlibs:Depends},
         ismrmrd-schema
Description: command-line tools for ISMRMRD
 The ISMRMRD format combines a mix of flexible data structures (XML header)
 and fixed structures (equivalent to C-structs) to represent MRI data.
 .
 In addition, the ISMRMRD format also specifies an image header for storing
 reconstructed images and the accompanying C++ library provides a convenient
 way of writing such images into HDF5 files along with generic arrays for
 storing less well defined data structures, e.g. coil sensitivity maps or
 other calibration data.
 .
 This package provides the command-line tools.

Package: ismrmrd-schema
Architecture: all
Multi-Arch: foreign
Section: misc
Depends: ${misc:Depends}
Description: schema for ISMRMRD
 The ISMRMRD format combines a mix of flexible data structures (XML header)
 and fixed structures (equivalent to C-structs) to represent MRI data.
 .
 In addition, the ISMRMRD format also specifies an image header for storing
 reconstructed images and the accompanying C++ library provides a convenient
 way of writing such images into HDF5 files along with generic arrays for
 storing less well defined data structures, e.g. coil sensitivity maps or
 other calibration data.
 .
 This package provides the XML schema.

=== debian/rules ===
--- 
+++ 
@@ -19,9 +19,26 @@
 override_dh_auto_build-indep:
 	dh_auto_build -- apidoc
 
+override_dh_install-arch:
+	find debian/tmp -name ismrmrd.xsd -delete
+	dh_install -a
+	d-shlibmove --commit \
+		    --multiarch \
+		    --devunversioned \
+		    --exclude-la \
+		    debian/tmp/usr/lib/*/*.so
+	find debian -name "lib*.la" -delete
+
+override_dh_auto_install-indep:
+	echo "No need to do install for architecture indep packages"
+
 override_dh_auto_installdocs-indep:
 	dh_installdocs --indep
 	dh_doxygen --indep
 
 override_dh_compress:
 	dh_compress --exclude=examples
+
+override_dh_missing-arch:
+	find debian/tmp -type f  \( -name '*.m' -o -name 'ismrmrd_c_example' \) -delete
+	dh_missing -a
